{{
** SEGA SC-3000 Emulator for PROP C3 **
**       TMS9928 TV Driver demo      **

AUTHOR: Francesco de Simone, www.digimorf.com

FILENAME: SC3000_TMS9928_TVOUT_DEMO_V010

COMMENTS: Early version, to be fixed.

HARDWARE REQUIREMENT:
Parallax Propeller C3 Board,
TV Set, NTSC/PAL, SEGA Gamepad interface

LICENSE: See end of file for terms of use

===========================================================================
}}

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000 ' final clock of 80Mhz
  
' Memory mapped registers
  base = $7F00  

  SPR_MAG          = base - 69
  SPR_SIZE         = base - 68
  INTERRUPT_ENABLE = base - 67    
  BLANK_SCREEN     = base - 66
  
  SCANLINE_BUFFER_IDX = base - 65
  RENDER_THIRD     = base - 61 
  RENDER_DELTA     = base - 59 
  RENDER_ROW       = base - 58
  RENDERER_CMD     = base - 56
  PATTERN_TABLE    = base - 52
  COLOR_TABLE      = base - 48 
  NAME_TABLE       = base - 44
  SPRITE_TABLE     = base - 40
  COLORS           = base - 36
  VIDEO_MODE       = base - 32
  INTERRUPT        = base - 28
  VRAM_PTR         = base - 24
  CLR_LOOKUP       = base - 20
  PIX_LOOKUP       = base - 16
  BORDERCOLOR      = base - 12
  SPRITE_GEN_TABLE = base - 8  
  SCANLINE_BUFFER  = base - 4
  SPRITE_BUFFER    = base 

VAR
    'byte vram[16*1024]
    
OBJ
    vdp   : "TMS9928_VDP_015"
    
'' ----------------------------------------------------------------------------------
PUB Main | msg, x,y, n
    msg := boot_emulator
    
    if ( msg == 0 )
      repeat  

PUB boot_emulator | n, tempVal, parPtr, i
    initVDP
    return 0

PUB initVDP
    long[VRAM_PTR] := @vram 
    vdp.start
    loadVRAM

'' **********************************************************************************  
'' UI ROUTINES **********************************************************************
'' **********************************************************************************
'' ----------------------------------------------------------------------------------          
PRI loadVRAM | regIndex, regValue

    repeat regIndex from 0 to 7
       vdp.write_reg ( byte[@vreg][regIndex] )
       vdp.write_reg ( $80+regIndex )  
        
'' ----------------------------------------------------------------------------------
PRI pauseMSec ( msec )
    waitcnt (( 80_000 * msec ) + cnt )
       
DAT
{{ Mode 0 example games }}

'vram file "VRAM_0_basic.bin"
'vreg file "VRegs_0_basic.bin"
 
{{ Mode 1 example games }}

'vram file "VRAM_1_popflamer.bin"
'vreg file "VRegs_1_popflamer.bin"

'vram file "VRAM_1_champion_baseball.bin"
'vreg file "VRegs_1_champion_baseball.bin"

'vram file "VRAM_1_champion_golf.bin"
'vreg file "VRegs_1_champion_golf.bin"

'vram file "VRAM_1_james_bond.bin"
'vreg file "VRegs_1_james_bond.bin"

'vram file "VRAM_1_Serizawa.bin"
'vreg file "VRegs_1_Serizawa.bin"

{{ Mode 2 example games }} 
'vreg file "MSX_Vregs_2_King'sValleyII.bin" 
'vram file "MSX_VRAM_2_King'sValleyII-1.bin"

vreg file "MSX_Vregs_2_NemesisII.bin"
vram file "MSX_VRAM_2_NemesisII-1.bin"

'vram file "VRAM_2_bombjack.bin"
'vram file "VRAM_2_bombjack-1.bin"
'vreg file "VRegs_2_bombjack.bin"

'vram file "VRAM_2_ChacknPop.bin"
'vreg file "VRegs_2_ChacknPop.bin"

'vram file "VRAM_2_pengland.bin"
'vram file "VRAM_2_pengland-1.bin" 
'vreg file "VRegs_2_pengland.bin"

'vram file "VRAM_2_CongoBongo.bin"
'vreg file "VRegs_2_CongoBongo.bin"
'vram file "VRAM_2_CongoBongo-1.bin"
'vreg file "VRegs_2_CongoBongo-1.bin"

'vram file "VRAM_2_starjacker.bin"
'vreg file "VRegs_2_starjacker.bin"
'vram file "VRAM_2_starjacker-1.bin"
'vreg file "VRegs_2_starjacker-1.bin"

'vram file "VRAM_2_Orguss.bin"
'vreg file "VRegs_2_Orguss.bin" 
'vram file "VRAM_2_Orguss-1.bin"
'vreg file "VRegs_2_Orguss-1.bin"

'vram file "VRAM_2_Choplifter.bin" 
'vram file "VRAM_2_Choplifter-1.bin"
'vreg file "VRegs_2_Choplifter.bin"

'vram file "VRAM_2_exerion.bin"  
'vram file "VRAM_2_exerion-1.bin"
'vreg file "VRegs_2_exerion.bin"
 
'vram file "VRAM_2_galaga.bin"
'vram file "VRAM_2_galaga-1.bin" 
'vreg file "VRegs_2_galaga.bin"

'vram file "VRAM_2_gulkave.bin"
'vram file "VRAM_2_gulkave-1.bin"  
'vreg file "VRegs_2_gulkave.bin"

'vram file "VRAM_2_girl_garden.bin"
'vram file "VRAM_2_girl_garden-1.bin"
'vreg file "Vregs_2_girl-garden-1.bin"

'vram file "VRAM_2_rocknbolt.bin"
'vram file "VRAM_2_rocknbolt-1.bin" 
'vreg file "Vregs_2_rocknbolt.bin" 

'vram file "VRAM_2_pitfall2.bin"
'vram file "VRAM_2_pitfall2-1.bin" 
'vreg file "Vregs_2_pitfall2.bin"   

'vram file "VRAM_2_zaxxon.bin"
'vram file "VRAM_2_zaxxon.bin-1"     
'vreg file "Vregs_2_zaxxon.bin"

'vram file "VRAM_2_Test.bin"
'vreg file "VRegs_2_Test.bin"

{{
  ______________________________________________________________________________________________________________________________
 |                                                   TERMS OF USE: MIT License                                                  |                                                            
 |______________________________________________________________________________________________________________________________|
|Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    |       
 |files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    |
 |modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software|
 |is furnished to do so, subject to the following conditions:                                                                   |
 |                                                                                                                              |
 |The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.|
 |                                                                                                                              |
 |THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          |
 |WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         |
 |COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   |
 |ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         |
 --------------------------------------------------------------------------------------------------------------------------------
 }}
 